/*------------------------------------------------------------------------------
 bin/djv_view/shortcut.h
 
 Shortcuts
 ---------

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_SHORTCUT_H
#define DJV_SHORTCUT_H

#include <djv_ui/shortcut.h>

namespace djv_view {
namespace shortcut {
using namespace djv_base;

//------------------------------------------------------------------------------
// Shortcuts

#if defined(WIN32)
#undef FILE_OPEN // XXX Windows name-space pollution.
#endif

enum SHORTCUT
{
  EXIT,
  FILE_OPEN,
  FILE_RELOAD,
  FILE_SAVE,
  FILE_SAVE_FRAME,
  FILE_CLOSE,
  FILE_LAYER_DEFAULT,
  FILE_LAYER_1,
  FILE_LAYER_2,
  FILE_LAYER_3,
  FILE_LAYER_4,
  FILE_LAYER_5,
  FILE_LAYER_6,
  FILE_LAYER_7,
  FILE_LAYER_8,
  FILE_LAYER_9,
  FILE_LAYER_10,
  FILE_LAYER_PREV,
  FILE_LAYER_NEXT,
  FILE_PROXY_NONE,
  FILE_PROXY_1_2,
  FILE_PROXY_1_4,
  FILE_PROXY_1_8,
  WINDOW_NEW,
  WINDOW_COPY,
  WINDOW_CLOSE,
  WINDOW_FIT,
  WINDOW_FULLSCREEN,
  WINDOW_TOOLBAR,
  WINDOW_PLAYBAR,
  VIEW_LEFT,
  VIEW_RIGHT,
  VIEW_UP,
  VIEW_DOWN,
  VIEW_CENTER,
  VIEW_ZOOM_IN,
  VIEW_ZOOM_OUT,
  VIEW_ZOOM_RESET,
  VIEW_RESET,
  VIEW_FIT,
  VIEW_HUD,
  IMAGE_FRAME_STORE,
  IMAGE_FRAME_STORE_LOAD,
  IMAGE_MIRROR_HORIZONTAL,
  IMAGE_MIRROR_VERTICAL,
  IMAGE_SCALE_NONE,
  IMAGE_SCALE_16_9,
  IMAGE_SCALE_1_85,
  IMAGE_SCALE_2_35,
  IMAGE_ROTATE_0,
  IMAGE_ROTATE_90,
  IMAGE_ROTATE_180,
  IMAGE_ROTATE_270,
  IMAGE_PROFILE,
  IMAGE_CHANNEL_DEFAULT,
  IMAGE_CHANNEL_1,
  IMAGE_CHANNEL_2,
  IMAGE_CHANNEL_3,
  IMAGE_CHANNEL_4,
  IMAGE_DISPLAY,
  IMAGE_DISPLAY_RESET,
  IMAGE_DISPLAY_1,
  IMAGE_DISPLAY_2,
  IMAGE_DISPLAY_3,
  IMAGE_DISPLAY_4,
  IMAGE_DISPLAY_5,
  IMAGE_DISPLAY_6,
  IMAGE_DISPLAY_7,
  IMAGE_DISPLAY_8,
  IMAGE_DISPLAY_9,
  IMAGE_DISPLAY_10,
  IMAGE_MAGNIFY,
  IMAGE_SAMPLE,
  IMAGE_HISTOGRAM,
  IMAGE_INFO,
  PLAYBACK_STOP,
  PLAYBACK_FORWARD,
  PLAYBACK_REVERSE,
  PLAYBACK_START,
  PLAYBACK_START_ABS,
  PLAYBACK_END,
  PLAYBACK_END_ABS,
  PLAYBACK_PREV,
  PLAYBACK_PREV_X10,
  PLAYBACK_PREV_X100,
  PLAYBACK_NEXT,
  PLAYBACK_NEXT_X10,
  PLAYBACK_NEXT_X100,
  PLAYBACK_IN_MARK,
  PLAYBACK_IN_RESET,
  PLAYBACK_OUT_MARK,
  PLAYBACK_OUT_RESET
};

//------------------------------------------------------------------------------
// Preferences

class Prefs : public djv_ui::Callback_Base
{
public:

  Prefs();
  ~Prefs();

  void shortcut(const List<djv_ui::shortcut::Shortcut> &);
  const List<djv_ui::shortcut::Shortcut> & shortcut() const;

private:

  List<djv_ui::shortcut::Shortcut> _shortcut;
};

//------------------------------------------------------------------------------
// Preferences Widget

class Prefs_Widget : public djv_ui::widget::Widget
{
public:

  Prefs_Widget();

private:

  DJV_CALLBACK(Prefs_Widget, shortcut_callback,
    const List<djv_ui::shortcut::Shortcut> &);
};

//------------------------------------------------------------------------------
// Labels

const List<Str> & label_shortcut();

extern const Str
  prefs_title;

//------------------------------------------------------------------------------
// Global

Prefs * prefs();

}
}

#endif
