/*------------------------------------------------------------------------------
 include/djv_base/io_.h
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

namespace djv_base {
namespace io {

inline void Io::set_8(const int8_t & in) throw (Error) { set_8(&in, 1); }
inline void Io::set_u8(const uint8_t & in) throw (Error) { set_u8(&in, 1); }
inline void Io::set_16(const int16_t & in) throw (Error) { set_16(&in, 1); }
inline void Io::set_u16(const uint16_t & in) throw (Error) { set_u16(&in, 1); }
inline void Io::set_32(const int32_t & in) throw (Error) { set_32(&in, 1); }
inline void Io::set_u32(const uint32_t & in) throw (Error) { set_u32(&in, 1); }
inline void Io::set_f32(const float & in) throw (Error) { set_f32(&in, 1); }

inline const uint8_t * Io::mmap_p() const { return _mmap_p; }
inline const uint8_t * Io::mmap_end() const { return _mmap_end; }

inline size_t Io::size() const { return _size; }

inline bool Io::endian() const { return _endian; }

}
}
