/*------------------------------------------------------------------------------
 include/djv_ui/image_io_ppm.h
 
 PPM Image I/O Widgets
 ---------------------
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_IMAGE_IO_PPM_H
#define DJV_UI_IMAGE_IO_PPM_H

#include <djv_image/io_ppm.h>
#include <djv_ui/image_io.h>

namespace djv_ui {
namespace image_io_ppm {

//------------------------------------------------------------------------------
// Save Widget

class Save : public image_io::Save
{
public:

  Save();
  ~Save();

  plugin::Plugin * copy() const;
  const Str & name() const;
  
  void set(djv_image::io::Plugin *);

private:

  DJV_CALLBACK(Save, type_callback, int);
  DJV_CALLBACK(Save, mode_callback, int);
  
  void plugin_update();
  void widget_update();

  djv_image::io::Plugin * _plugin;
  djv_image::io_ppm::Save_Option _option;

  struct _Save;
  std::auto_ptr<_Save> _p;
};

//------------------------------------------------------------------------------
// Labels

extern const Str
  label_type_group,
  label_type,
  label_mode_group,
  label_mode;

}
}

#endif

