/*------------------------------------------------------------------------------
 include/djv_ui/tab.h
 
 Tab Widget
 ----------

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_TAB_WIDGET_H
#define DJV_UI_TAB_WIDGET_H

#include <djv_ui/widget.h>
#include <FL/Fl_Tabs.H>

namespace djv_ui {
namespace tab {

//------------------------------------------------------------------------------
// Widget

class Widget : public Fl_Tabs, public widget::Base
{
public:

  Widget();
  virtual ~Widget();
  
  // Value.

  void set(int);
  int get() const;
  Signal<int> sig;

  // Tabs.
  
  void tab_add(const Str & name, widget::Base *);
  void tab_insert(const Str & name, widget::Base *, int = 0);
  void tab_name(const Str & name, int tab);
  void tab_del(int tab);
  void tab_del();
  int tab_size() const;
  
  // Widget.
  
  virtual int handle(int);
  virtual void show();
  virtual void draw();
  
  // Layout.

  virtual void dirty();
  virtual void geom(const Box2i &);
  virtual void resize(int, int, int, int);
  virtual const Box2i & geom() const;
  virtual int visible() const;

  // Debugging.
  
  virtual Str dbg_name() const { return "djv::ui::tab::Widget"; }

private:

  DJV_FL_WIDGET_CALLBACK(Widget, widget_callback);

  List<widget::Base *> _list; // XXX Should be layout item.
  Vec2i _size_tab;
};

}
}

#endif

