/*------------------------------------------------------------------------------
 lib/djv_image/wgl_offscreen.h
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef _DJV_IMAGE_WGL_OFFSCREEN_H
#define _DJV_IMAGE_WGL_OFFSCREEN_H

#include "gl_offscreen.h"

namespace djv_image {
namespace gl_offscreen {

//------------------------------------------------------------------------------
// Pixel Buffer

class _Pbuffer
{
public:

  _Pbuffer();
  ~_Pbuffer();

  void init(const Info &, int format) throw (Error);
  void current() throw (Error);
  
  const Info & info() const { return _info; }

private:

  Info _info;
  HDC _device;
  HGLRC _context;
  HPBUFFERARB _pbuffer;
};

class _Wgl_Pbuffer_Factory : public _Pbuffer_Factory
{
public:

  _Wgl_Pbuffer_Factory();
  ~_Wgl_Pbuffer_Factory();
  
  void init() throw (Error);
  void add(_Pbuffer *);

  _Pbuffer * get(const Info &) throw (Error);
  
  int format() const { return _format; }
  
private:

  List<_Pbuffer *> _list;
  static const int _list_max = 10;
  int _format;
};

//------------------------------------------------------------------------------
// Labels

const Str
  error_wgl_pbuffer_create = "PBuffer Create: %%",
  error_wgl_pbuffer_device = "PBuffer Device: %%";

}
}

#endif
