/*------------------------------------------------------------------------------
 lib/djv_ui/layout_stack.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#undef DJV_DBG
//#define DJV_DBG

#include <djv_ui/layout_stack.h>

namespace djv_ui {
namespace layout {

Stack::Stack(Item * parent) :
  Layout(parent)
{}

Stack::~Stack()
{}

void Stack::dirty()
{
  DJV_DBG_OBJ("Stack::dirty");
  
  Layout::dirty();

  Vec2i size;
  const List<Item *> & list = this->list();
  for (uint i = 0; i < list.size(); ++i)
    size = vec::max(list[i]->size_hint(), size);
  
  size_hint(size + margin() * 2);
}

void Stack::geom(const Box2i & in)
{
  DJV_DBG_OBJ("Stack::geom");
  DJV_DBG_PRN("in = " << in);

  Layout::geom(in);
  
  const List<Item *> & list = this->list();
  for (uint i = 0; i < list.size(); ++i)
    list[i]->geom(Box2i(
      in.x + margin(),
      in.y + margin(),
      in.w - margin() * 2,
      in.h - margin() * 2));
}

const Box2i & Stack::geom() const { return Layout::geom(); }

}
}

