/*------------------------------------------------------------------------------
 lib/djv_ui/style_fnc.cxx
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include <djv_ui/style.h>

namespace djv_ui {
namespace style {

bool operator == (const Color & a, const Color & b)
{
  return
    a.foreground == b.foreground &&
    a.background == b.background &&
    a.background2 == b.background2 &&
    a.select == b.select;
}

bool operator != (const Color & a, const Color & b)
  { return ! (a == b); }

DJV_STR_OPERATOR_SET(COLOR, label_color())
DJV_STR_OPERATOR_GET(COLOR, label_color())

Str & operator >> (Str & in, Color & out) throw (Str)
{
  in >> out.foreground;
  in >> out.background;
  in >> out.background2;
  in >> out.select;
  return in;
}

Str & operator << (Str & out, const Color & in)
{
  out << in.foreground;
  out << in.background;
  out << in.background2;
  out << in.select;
  return out;
}

DJV_STR_OPERATOR_SET(SIZE, label_size())
DJV_STR_OPERATOR_GET(SIZE, label_size())

const List<Str> & label_color()
{
  static const List<Str> data = List<Str>() <<
    "Dark" <<
    "Neutral" <<
    "Light" <<
    "Custom";
  return data;
}

const List<Str> & label_size()
{
  static const List<Str> data = List<Str>() <<
    "Small" <<
    "Medium" <<
    "Large";
  return data;
}

}
}

