/*------------------------------------------------------------------------------
 lib/djv_ui/style_prefs.cxx
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#undef DJV_DBG
//#define DJV_DBG

#include <djv_ui/prefs.h>
#include <djv_ui/style.h>

namespace djv_ui {
namespace style {

Prefs::Prefs() :
  _color(COLOR_NEUTRAL),
  _size(SIZE_MEDIUM)
{
  DJV_DBG_OBJ("Prefs::Prefs");
  
  prefs::Prefs prefs(prefs::prefs_global(), "style");
  prefs::get(&prefs, "color", &_color);
  prefs::get(&prefs, "color_custom", &_color_custom);
  prefs::get(&prefs, "size", &_size);
}

Prefs::~Prefs()
{
  DJV_DBG_OBJ("Prefs::~Prefs");

  prefs::Prefs prefs(prefs::prefs_global(), "style");
  prefs::set(&prefs, "color", _color);
  prefs::set(&prefs, "color_custom", _color_custom);
  prefs::set(&prefs, "size", _size);
}
  
void Prefs::color(COLOR in)
{
  if (in == _color) return;
  
  _color = in;
  
  global()->color(_color);
}
  
COLOR Prefs::color() const { return _color; }
  
void Prefs::color_custom(const Color & in)
{
  if (in == _color_custom) return;
  
  _color_custom = in;
  
  global()->color_custom(_color_custom);
}
  
const Color & Prefs::color_custom() const { return _color_custom; }

void Prefs::size(SIZE in)
{
  if (in == _size) return;
  
  _size = in;
  
  global()->size(_size);
}
  
SIZE Prefs::size() const { return _size; }

}
}

