#define DJV_DBG

#include <djv_base/dbg.h>
#include <djv_base/app.h>

using namespace djv_base;

void cmdln(Str & in) throw (Error)
{
  DJV_DBG_OBJ("cmdln");
  DJV_DBG_PRN("in = " << in);
  
  List<Str> arg_list;
  Str arg;
  try
  {
  while (! in.empty())
  {
    in >> arg;
  
    if ("-bool" == arg)
    {
      bool value = false;
      in >> value;
      DJV_DBG_PRN("bool = " << value);
    }
    
    else arg_list += arg;
  }
  }
  catch (Str) { throw Error(arg); }
  
  if (! arg_list.size()) throw Error("input 1");
  DJV_DBG_PRN("input 1 = " << arg_list.pop_front());
  
  if (! arg_list.size()) throw Error("input 2");
  DJV_DBG_PRN("input 2 = " << arg_list.pop_front());

  if (! arg_list.empty()) throw Error(arg_list[0]);
}

int main(int argc, char ** argv)
{
  List<Str> cmdln_list;
  for (int i = 1; i < argc; ++i)
    cmdln_list += str::serialize(Str(argv[i]));
  Str cmdln_arg = str::join(cmdln_list, ' ');
  
  try { cmdln(cmdln_arg); }
  catch (Error in)
  {
    error::print(in);
    return 1;
  }
  
  return 0;
}

