#include <djv_ui/file_browser.h>
#include <djv_ui/app.h>

class App : public djv_ui::app::App
{
public:

  App(int & argc, char ** argv);

private:

  DJV_CALLBACK(App, widget_callback, const djv_base::File &) { print(in); }
  DJV_CALLBACK(App, close_callback, bool) { exit(); }
};

App::App(int & argc, char ** argv) :
  djv_ui::app::App("file_browser", argc, argv)
{
  using namespace djv_ui;

  valid(true);
  
  file_browser::set(this, widget_callback);
  file_browser::global()->close_sig.set(this, close_callback);
}

int main(int argc, char ** argv) { return App(argc, argv).exec(); }

