#include <djv_image/time.h>

namespace misc {
using namespace djv_base;

typedef djv_image::time::Speed Speed;

struct Time
{
  Time() :
    start(0),
    size(0),
    in(0),
    out(0)
  {}
  Time(int start, int size, const Speed & speed = Speed()) :
    start(start),
    size(size),
    in(0),
    out(0)
  {}
  
  int start;
  int size;
  int in, out;
  Speed speed;
};

struct Clip
{
  Clip() {}
  Clip(const Str & name, const Time & time) :
    name(name),
    time(time)
  {}
  
  Str name;
  Time time;
};

struct Project
{
  Time time;
  List<Clip *> clip;
};

}
